#!/bin/bash
# /home/david/SyncthingFolders/allScripts/YPlayer/songSearch.sh
# huge comments are from http://patorjk.com/software/taag/#p=display&h=2&v=0&c=bash&f=Univers&t=while
#test if musicpath exists: 
if [ -f ~/.musicpath ] 
then
export musicpath=$(cat ~/.musicpath)
else
MYOUT=$(yad --title="pick Music location" --center --form --field="pick Music folder:DIR" "${homepath}/Music")
echo $MYOUT | sed 's/|//' > ~/.musicpath
export musicpath=$(echo $MYOUT | sed 's/|//')
fi


export SCRIPTPATH=$(cat ~/.scriptpath);# should give the name of the script

> /tmp/searchList
> /tmp/mylist
> /tmp/searchtest
> /tmp/artists
> /tmp/albums
> /tmp/songs
> /tmp/artists2
> /tmp/albums2
> /tmp/songs2
cd $musicpath
theText=$(cat /tmp/songsearchterm)
term=`yad --title="Search for Music" --geometry=+800+20 --center --always-print-result --form --field="search term:" "$theText"`
output=$?
echo 1st yad section output is: =${output}= 0=okay, 1=cancel
[[ $output = "1" ]] && exit

echo -----
echo "the search term is =$term= <--- right there"
echo -----

term2=`echo "${term%%|*}"`
term="$term2"
echo "$term" | tee /tmp/songsearchterm

find -type f \( -iname \*.mp3 -o -iname \*.m4a -o -iname \*.ogg \) | sed 's/\.\///' | grep -i "$term" > /tmp/searchtest


#                                                       
#                      88           88  88              
#                      88           ""  88              
#                      88               88              
#  8b      db      d8  88,dPPYba,   88  88   ,adPPYba,  
#  `8b    d88b    d8'  88P'    "8a  88  88  a8P_____88  
#   `8b  d8'`8b  d8'   88       88  88  88  8PP"""""""  
#    `8bd8'  `8bd8'    88       88  88  88  "8b,   ,aa  
#      YP      YP      88       88  88  88   `"Ybbd8"'  
#                                                       
#                                  

echo line 56

while IFS= read -r line
do

echo "line is: =$line="
    
Artist=$(echo "$line" | cut -d/ -f1 | uniq | grep -i "$term");# is the term in "Artist"?
Artist2=$(echo "$line" | cut -d/ -f1)

if [ -z "$Artist" ]
then
      echo yad --text="Artist =$Artist2= does *not* contain =$term="
else
		echo Artist is =$Artist=
    # if the term is in the Artist name, you'll want the whole
    # Artist list, so write this in for later and move on to the next line
		echo "$Artist" >> /tmp/artists
    #continue
fi

#yad --text="$line"
Album=$(echo "$line" | cut -d/ -f2 | uniq | grep -i "$term")
Album2=$(echo "$line" | cut -d/ -f2)

if [ -z "$Album" ]
then
      echo yad --text="Album =$Album2= does *not* contain =$term="
else
		#yad --text=" Album is =$Album="
    # if the term is in the Album name, you'll want the whole
    # album, so write this in for later and move on to the next line
		echo "$line" | cut -d'/' -f1-2 >> /tmp/albums
    #continue <-- don't continue, because maybe you want just the song of the album name
fi

# TODO what's this doing again?? if skipped, doesn't find songs
# if the Artist does not have the search term in it then its the song you want
[ -z "$Artist" ] && Song=$(echo "$line" | cut -d/ -f3 | grep -i "$term") || Song=$(echo "$line" | cut -d/ -f3 | sed "s/${Artist2}//g" | grep -i "$term")


if [ -z "$Song" ]
then
      echo "=$Song= does *not* contain $term"
      # will naturally loop to the next line
else
		echo \$Song is =$Song=
		echo "$line" >> /tmp/songs
fi

echo "
"

done < /tmp/searchtest

#                                                     
#           88                                        
#           88                                        
#           88                                        
#   ,adPPYb,88   ,adPPYba,   8b,dPPYba,    ,adPPYba,  
#  a8"    `Y88  a8"     "8a  88P'   `"8a  a8P_____88  
#  8b       88  8b       d8  88       88  8PP"""""""  
#  "8a,   ,d88  "8a,   ,a8"  88       88  "8b,   ,aa  
#   `"8bbdP"Y8   `"YbbdP"'   88       88   `"Ybbd8"'  
#                                                     
#                                                               




# next, get rid of repeats that are the same in all 3 categories
echo ------- artists:
sort +1 -u /tmp/artists > /tmp/artists2
cat /tmp/artists2
echo ------- albums:
sort +2 -u /tmp/albums > /tmp/albums2
cat /tmp/albums2
echo ------- songs:
sort +2 -u /tmp/songs > /tmp/songs2
cat /tmp/songs2

##################################   construct yad dialog ##############
> /tmp/musicsearch

input="/tmp/artists2"
while IFS= read -r line
do
  echo FALSE >> /tmp/musicsearch
  echo "Artist" >> /tmp/musicsearch
  echo "$line" >> /tmp/musicsearch
done < "$input"

input="/tmp/albums2"
while IFS= read -r line
do
  echo FALSE >> /tmp/musicsearch
  echo "Album" >> /tmp/musicsearch
  echo "$line" >> /tmp/musicsearch
done < "$input"

input="/tmp/songs2"
while IFS= read -r line
do
  echo FALSE >> /tmp/musicsearch
  echo "Songs" >> /tmp/musicsearch
  echo "$line" >> /tmp/musicsearch
done < "$input"

cr="
"



#                                                                                     
#                                                  88                             88  
#                                                  88    ,d                     ,d88  
#                                                  88    88                   888888  
#  8b,dPPYba,   ,adPPYba,  ,adPPYba,  88       88  88  MM88MMM  ,adPPYba,         88  
#  88P'   "Y8  a8P_____88  I8[    ""  88       88  88    88     I8[    ""         88  
#  88          8PP"""""""   `"Y8ba,   88       88  88    88      `"Y8ba,          88  
#  88          "8b,   ,aa  aa    ]8I  "8a,   ,a88  88    88,    aa    ]8I         88  
#  88           `"Ybbd8"'  `"YbbdP"'   `"YbbdP'Y8  88    "Y888  `"YbbdP"'         88  
#                                                                                     
#                                                                                     
                                                                                                          
                                                                  

> /tmp/searchoutput
cat /tmp/musicsearch | sed "s/\&/\&amp;/g" | yad --title="initial search results" --geometry=900x600  --dclick-action='bash -c "kill -USR1 $YAD_PID"' --center --list --checklist --column "check" --column "type" --column "Item" | sed "s/\&amp;/\&/g" > /tmp/searchoutput
output=$?
echo ~~~~~~~~~~~
echo output is: =${output}= 0=okay, 1=cancel
[[ $output = "1" ]] && exit



echo OUTPUT is $(cat /tmp/searchoutput)



#                                                                                                              
#                                  88                                   88  88                                 
#                                  88                                   88  ""               ,d                
#                                  88                                   88                   88                
#  88,dPYba,,adPYba,   ,adPPYYba,  88   ,d8   ,adPPYba,                 88  88  ,adPPYba,  MM88MMM  ,adPPYba,  
#  88P'   "88"    "8a  ""     `Y8  88 ,a8"   a8P_____88                 88  88  I8[    ""    88     I8[    ""  
#  88      88      88  ,adPPPPP88  8888[     8PP"""""""                 88  88   `"Y8ba,     88      `"Y8ba,   
#  88      88      88  88,    ,88  88`"Yba,  "8b,   ,aa                 88  88  aa    ]8I    88,    aa    ]8I  
#  88      88      88  `"8bbdP"Y8  88   `Y8a  `"Ybbd8"'                 88  88  `"YbbdP"'    "Y888  `"YbbdP"'  
#                                                                                                              
#                                                                                                              

# next: take results and use to make playlist from all results - like artist + album + song

input="/tmp/searchoutput"
> ${musicpath}/searchPlaylist.m3u



#                                                       
#                      88           88  88              
#                      88           ""  88              
#                      88               88              
#  8b      db      d8  88,dPPYba,   88  88   ,adPPYba,  
#  `8b    d88b    d8'  88P'    "8a  88  88  a8P_____88  
#   `8b  d8'`8b  d8'   88       88  88  88  8PP"""""""  
#    `8bd8'  `8bd8'    88       88  88  88  "8b,   ,aa  
#      YP      YP      88       88  88  88   `"Ybbd8"'  
#                                                       
#                                                       
                                                                                              
                                                                                                                                          

while IFS= read -r line
do
  
  echo "
  line is: =$line="
  line2=$(echo $line | sed "s/\|TRUE\|//")
  line=$line2;line3=$(echo $line | sed "s/\&/\&amp;/g")
  #yad --text="new line is: =$line3="
  
#                                                                 
#         db                              88                      
#        d88b                      ,d     ""               ,d     
#       d8'`8b                     88                      88     
#      d8'  `8b      8b,dPPYba,  MM88MMM  88  ,adPPYba,  MM88MMM  
#     d8YaaaaY8b     88P'   "Y8    88     88  I8[    ""    88     
#    d8""""""""8b    88            88     88   `"Y8ba,     88     
#   d8'        `8b   88            88,    88  aa    ]8I    88,    
#  d8'          `8b  88            "Y888  88  `"YbbdP"'    "Y888  
#                                                                 
#   
echo "#####################################   Artist to playlist"
if [[ $line == *"|Artist"* ]]; then
  echo "Artist!!!!!"
  Artist=$(echo "$line" | cut -d'|' -f3 );Artist3=$(echo $Artist | sed "s/\&/\&amp;/g")
  #yad --text="Artist is =$Artist3="

cd """${musicpath}/${Artist}"""
# this format is Album/Song:
find -type f \( -iname \*.mp3 -o -iname \*.m4a -o -iname \*.ogg \) | sed 's/\.\///' > /tmp/mylist
	
# next: put all positive artists songs in list to choose from  
> /tmp/searchList

while IFS= read -r lineB
do
  echo FALSE >> /tmp/searchList
  echo "$lineB" >> /tmp/searchList
done < "/tmp/mylist"
cr="
"
cat /tmp/searchList | sed "s/\&/\&amp;/g" | yad --title="pick yer $Artist songs" --geometry=900x600 --dclick-action='bash -c "kill -USR1 $YAD_PID"' --center --list --checklist --column "check" --column "Item" | sed "s/\&amp;/\&/g" > /tmp/searchList2
#                                                                      
#         db         88  88                                            
#        d88b        88  88                                            
#       d8'`8b       88  88                                            
#      d8'  `8b      88  88,dPPYba,   88       88  88,dPYba,,adPYba,   
#     d8YaaaaY8b     88  88P'    "8a  88       88  88P'   "88"    "8a  
#    d8""""""""8b    88  88       d8  88       88  88      88      88  
#   d8'        `8b   88  88b,   ,a8"  "8a,   ,a88  88      88      88  
#  d8'          `8b  88  8Y"Ybbd8"'    `"YbbdP'Y8  88      88      88  
#                                                                      
#                                                                      
#####  convert "TRUE|Album/Song.mp3|" to Artist/Album/Song.mp3

while IFS= read -r lineC
do
  echo line is: ="$lineC"=
  line2=$(echo $lineC | sed "s/TRUE//" | sed "s/|//g")
  lineC=$Artist/$line2
  echo new searchPlaylist line is: ="$lineC"=
  echo $lineC >> ${musicpath}/searchPlaylist.m3u
done < "/tmp/searchList2"

fi


echo "#####################################   Album to playlist"
if [[ $line == *"Album"* ]]; then
  echo "Album!"
  Album=$(echo "$line" | cut -d'|' -f3 )
    echo =$Album=
      #yad --text="Album: =$Album=";#  this includes the Artist/Album path
      	 cd "${musicpath}/${Album}/"
	 #function prepend() { while read line; do echo "${1}${line}"; done; }
	find "$(cd .; pwd)" -type f \( -iname \*.mp3 -o -iname \*.m4a -o -iname \*.ogg \) | sed 's/.*\/Music\///' > /tmp/mylist





#                                                                 
#   ad88888ba                                                     
#  d8"     "8b                                                    
#  Y8,                                                            
#  `Y8aaaaa,     ,adPPYba,   8b,dPPYba,    ,adPPYb,d8  ,adPPYba,  
#    `"""""8b,  a8"     "8a  88P'   `"8a  a8"    `Y88  I8[    ""  
#          `8b  8b       d8  88       88  8b       88   `"Y8ba,   
#  Y8a     a8P  "8a,   ,a8"  88       88  "8a,   ,d88  aa    ]8I  
#   "Y88888P"    `"YbbdP"'   88       88   `"YbbdP"Y8  `"YbbdP"'  
#                                          aa,    ,88             
#
# next: put all positive artists songs in list to choose from  
> /tmp/searchList
while IFS= read -r lineD
do
  echo TRUE >> /tmp/searchList
  echo "$lineD" >> /tmp/searchList
done < "/tmp/mylist"
cr="
"
cat /tmp/searchList | sed "s/\&/\&amp;/g" | yad --title="pick yer $Album songs" --geometry=500x600 --dclick-action='bash -c "kill -USR1 $YAD_PID"' --center --list --checklist --column "check" --column "Item" | sed "s/\&amp;/\&/g" > /tmp/searchList2

#####  convert "TRUE|Album/Song.mp3|" to Artist/Album/Song.mp3

while IFS= read -r lineE
do
echo ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  echo line is: ="$lineE"=
  line2=$(echo $lineE | sed "s/TRUE//" | sed "s/|//g")
  lineE=$line2
  echo new searchPlaylist line is: ="$lineE"=
  echo $lineE >> ${musicpath}/searchPlaylist.m3u
done < "/tmp/searchList2"


	 cd "${musicpath}"
fi


#####################################   Songs to playlist
if [[ $line == *"Songs"* ]]; then
  echo "Songs!"
  Songs=$(echo "$line" | cut -d'|' -f3)
    echo =$Songs=
    #yad --text="Songs: =$Songs="
    echo $Songs >> ${musicpath}/searchPlaylist.m3u
fi
  
  
done < "$input"



#                                                     
#           88                                        
#           88                                        
#           88                                        
#   ,adPPYb,88   ,adPPYba,   8b,dPPYba,    ,adPPYba,  
#  a8"    `Y88  a8"     "8a  88P'   `"8a  a8P_____88  
#  8b       88  8b       d8  88       88  8PP"""""""  
#  "8a,   ,d88  "8a,   ,a8"  88       88  "8b,   ,aa  
#   `"8bbdP"Y8   `"YbbdP"'   88       88   `"Ybbd8"'  
#                                                     
#                                                     
                                    


#is the playlist empty? if yes then just exit
mym3u="${musicpath}/searchPlaylist.m3u"
[ -s "${mym3u}" ] && echo has data || exit

# this is here because you still want it running if you exit before this:
#kill the mplayer kill script:
killpid=$(cat /tmp/killpid)
kill $killpid

pkill mplayer
wmctrl -c "Yad Player" 
sleep 1
bash "${SCRIPTPATH}" "searchPlaylist" 
